#pragma semicolon 1
#pragma newdecls required

#include <sdktools_functions>
#include <sdktools_entinput>
#include <vip_core>

public Plugin myinfo = 
{
	name = "[ViP Core] TwoGuns",
	version = "2.3.5",
	description	= "Два оружия в одном слоте для ViP Статуса",
	author = "Scarface_slv, (rewritten by Nek.'a 2x2 | ggwp.site )",
	url = "https://ggwp.site/"
};

static const char g_sFeature[] = "two_guns";

bool
	g_bReload[MAXPLAYERS+1],
	bEnable;

Handle
	g_hArray[MAXPLAYERS+1][2],
	g_hTrie;

int
	g_iSlot,
	g_iAmmoClient[MAXPLAYERS+1][2][2],
	g_iReservClient[MAXPLAYERS+1][2][2],
	iButton;

char
	BUTTONS,
	Engine_Version;

float
	g_iFloodClient[MAXPLAYERS+1][2],
	fAntiflood;

#define GAME_UNDEFINED 0
#define GAME_CSS_34 1
#define GAME_CSS 2
#define GAME_CSGO 3

int GetCSGame()
{
	if (GetFeatureStatus(FeatureType_Native, "GetEngineVersion") == FeatureStatus_Available) 
	{ 
		switch (GetEngineVersion()) 
		{ 
			case Engine_SourceSDK2006: return GAME_CSS_34; 
			case Engine_CSS: return GAME_CSS; 
			case Engine_CSGO: return GAME_CSGO; 
		} 
	}
	return GAME_UNDEFINED;
}

public void OnPluginStart()
{
	Engine_Version = GetCSGame(); if(Engine_Version == GAME_UNDEFINED) SetFailState("Game is not supported!");
	
	ConVar cvar;
	cvar = CreateConVar("sm_vip_twoguns_enable", "1", "Включить/выключить плагин двойного оружия", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Enable);
	bEnable = cvar.BoolValue;
	
	cvar = CreateConVar("sm_vip_twoguns_slot", "0", "Какие виды оружий можно носить по два? Только автоматы - 1. Только пистолеты - 2. Обо вида - 0", _, true, 0.0, true, 25.0);
	cvar.AddChangeHook(CVarChanged_Slot);
	g_iSlot = cvar.IntValue;
	
	cvar = CreateConVar("sm_vip_twoguns_button", "17", "На какую клавишу будет работать? 0 - буква \"E\", 1 - прыжок и до 25", _, true, 0.0, true, 25.0);
	cvar.AddChangeHook(CVarChanged_Button);
	iButton = cvar.IntValue;
	
	cvar = CreateConVar("sm_vip_twoguns_antiflood", "0.40", "Через какое время можно использовать смену оружия повторно (время в секундах)");
	cvar.AddChangeHook(CVarChangedAntiflood);
	fAntiflood = cvar.FloatValue;

	g_hTrie = CreateTrie();

	HookEvent("player_hurt", Event_PlayerHurt);
	HookConVarChange(FindConVar("mp_restartgame"), OnConVarRestart);

	AutoExecConfig(true, "TwoGuns", "vip");
}

public void CVarChanged_Enable(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	bEnable = cvar.BoolValue;
}

public void OnConVarChangeSlot(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	LoadTrieValue(StringToInt(newValue));
}

public void CVarChangedAntiflood(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fAntiflood = cvar.FloatValue;
}

public void CVarChanged_Button(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	iButton = cvar.IntValue;
}

public void CVarChanged_Slot(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	g_iSlot = cvar.IntValue;
}

public void OnConfigsExecuted()
{
	switch(iButton)
	{
		case 0: BUTTONS = IN_USE;
		case 1: BUTTONS = IN_JUMP;
		case 2: BUTTONS = IN_ATTACK;
		case 3: BUTTONS = IN_DUCK;
		case 4: BUTTONS = IN_FORWARD;
		case 5: BUTTONS = IN_BACK;
		case 6: BUTTONS = IN_ATTACK3;
		case 7: BUTTONS = IN_CANCEL;
		case 8: BUTTONS = IN_LEFT;
		case 9: BUTTONS = IN_RIGHT;
		case 10: BUTTONS = IN_MOVELEFT;
		case 11: BUTTONS = IN_MOVERIGHT;
		case 12: BUTTONS = IN_ATTACK2;
		case 13: BUTTONS = IN_RUN;
		case 14: BUTTONS = IN_RELOAD;
		case 15: BUTTONS = IN_ALT1;
		case 16: BUTTONS = IN_ALT2;
		case 17: BUTTONS = IN_SCORE;
		case 18: BUTTONS = IN_SPEED;
		case 19: BUTTONS = IN_WALK;
		case 20: BUTTONS = IN_ZOOM;
		case 21: BUTTONS = IN_WEAPON1;
		case 22: BUTTONS = IN_WEAPON2;
		case 23: BUTTONS = IN_BULLRUSH;
		case 24: BUTTONS = IN_GRENADE1;
		case 25: BUTTONS = IN_GRENADE2;
	}
}

public void OnPluginEnd()
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
		VIP_UnregisterFeature(g_sFeature);
}

public void VIP_OnVIPLoaded(){VIP_RegisterFeature(g_sFeature, BOOL);}

public void OnConVarRestart(Handle convar, const char[] oldValue, const char[] newValue) 
{
	for(int i = 1; i <= MaxClients; i++) if(IsClientInGame(i))
	{
		ClearArray(g_hArray[i][0]); 
		ClearArray(g_hArray[i][1]);
	}
}

void LoadTrieValue(int iSlot)
{
	if(g_hTrie != INVALID_HANDLE) ClearTrie(g_hTrie);
	switch(iSlot)
	{
		case 1: SetWeapon(0);
		case 2: SetWeapon(1);
		default: 
		{
			SetWeapon(1);
			SetWeapon(0);
		}
	}
}

void SetWeapon(int iSlot)
{
	if(Engine_Version == GAME_CSGO)
	{
		switch(iSlot)
		{
			case 0:
			{
				SetTrieValue(g_hTrie,	"nova", 0);
				SetTrieValue(g_hTrie,	"xm1014", 0);
				SetTrieValue(g_hTrie,	"sawedoff", 0);
				SetTrieValue(g_hTrie,	"mag7", 0);
				SetTrieValue(g_hTrie,	"m249", 0);
				SetTrieValue(g_hTrie,	"negev", 0);
				SetTrieValue(g_hTrie,	"mac10",	0);
				SetTrieValue(g_hTrie,	"mp5sd", 0);
				SetTrieValue(g_hTrie,	"mp7", 0);
				SetTrieValue(g_hTrie,	"mp9", 0);
				SetTrieValue(g_hTrie,	"ump45", 0);
				SetTrieValue(g_hTrie,	"p90", 0);
				SetTrieValue(g_hTrie,	"bizon", 0);
				SetTrieValue(g_hTrie,	"galilar", 0);
				SetTrieValue(g_hTrie,	"famas", 0);
				SetTrieValue(g_hTrie,	"ak47", 0);
				SetTrieValue(g_hTrie,	"m4a1", 0);
				SetTrieValue(g_hTrie,	"m4a1_silencer", 0);
				SetTrieValue(g_hTrie,	"aug", 0);
				SetTrieValue(g_hTrie,	"sg556", 0);
				SetTrieValue(g_hTrie,	"ssg08", 0);
				SetTrieValue(g_hTrie,	"awp", 0);
				SetTrieValue(g_hTrie,	"g3sg1", 0);
				SetTrieValue(g_hTrie,	"scar20", 0);
			}
			case 1:
			{
				SetTrieValue(g_hTrie,	"glock",	1);
				SetTrieValue(g_hTrie,	"usp_silencer",	1);
				SetTrieValue(g_hTrie,	"hkp2000",	1);
				SetTrieValue(g_hTrie,	"fiveseven",1);
				SetTrieValue(g_hTrie,	"elite",	1);
				SetTrieValue(g_hTrie,	"p250", 1);
				SetTrieValue(g_hTrie,	"tec9",	1);
				SetTrieValue(g_hTrie,	"cz75a",	1);
				SetTrieValue(g_hTrie,	"deagle",	1);
				SetTrieValue(g_hTrie,	"revolver",	1);
			}
		}
	}
	else
	{
		switch(iSlot)
		{
			case 0:
			{
				SetTrieValue(g_hTrie,	"m3", 0);
				SetTrieValue(g_hTrie,	"xm1014", 0);
				SetTrieValue(g_hTrie,	"mac10",	0);
				SetTrieValue(g_hTrie,	"tmp", 0);
				SetTrieValue(g_hTrie,	"mp5navy", 0);
				SetTrieValue(g_hTrie,	"ump45", 0);
				SetTrieValue(g_hTrie,	"p90", 0);
				SetTrieValue(g_hTrie,	"galil", 0);
				SetTrieValue(g_hTrie,	"famas", 0);
				SetTrieValue(g_hTrie,	"ak47", 0);
				SetTrieValue(g_hTrie,	"m4a1", 0);
				SetTrieValue(g_hTrie,	"scout", 0);
				SetTrieValue(g_hTrie,	"sg550", 0);
				SetTrieValue(g_hTrie,	"aug", 0);
				SetTrieValue(g_hTrie,	"awp", 0);
				SetTrieValue(g_hTrie,	"g3sg1", 0);
				SetTrieValue(g_hTrie,	"sg552", 0);
				SetTrieValue(g_hTrie,	"m249", 0);
			}
			case 1:
			{
				SetTrieValue(g_hTrie,	"glock",	1);
				SetTrieValue(g_hTrie,	"usp",	1);
				SetTrieValue(g_hTrie,	"p228",	1);
				SetTrieValue(g_hTrie,	"deagle",1);
				SetTrieValue(g_hTrie,	"elite",	1);
				SetTrieValue(g_hTrie,	"fiveseven", 1);
			}
		}
	}
}

public void OnMapStart()
{
	LoadTrieValue(g_iSlot);
	for(int i = 1; i <= MaxClients; i++) 
	{
		if(g_hArray[i][0] != INVALID_HANDLE && g_hArray[i][1] != INVALID_HANDLE) 
		{
			ClearArray(g_hArray[i][0]); 
			ClearArray(g_hArray[i][1]);
		}
		else 
		{
			g_hArray[i][0] = CreateArray(8); 
			g_hArray[i][1] = CreateArray(10); 
		}
	}
}

public void Event_PlayerHurt(Handle event, const char[] name, bool dontBroadcast) 
{ 
	if(GetEventInt(event, "health") < 1) OnClientDisconnect(GetClientOfUserId(GetEventInt(event, "userid")));
}

public Action CS_OnBuyCommand(int client, const char[] weapon) 
{
	if(!VIP_IsClientVIP(client) || !VIP_IsClientFeatureUse(client, g_sFeature))
		return Plugin_Continue; 

	int iSlot; 
	if (!GetTrieValue(g_hTrie, weapon, iSlot) || GetPlayerWeaponSlot(client, iSlot) == -1)
		return Plugin_Continue;
	
	switch(GetArraySize(g_hArray[client][iSlot]))
	{
		case 0: PushArrayString(g_hArray[client][iSlot], weapon); 
		case 2: PushArrayString(g_hArray[client][iSlot], weapon); 
	}
	return Plugin_Continue; 
}

public Action CS_OnCSWeaponDrop(int client, int weapon) 
{ 
	if(!VIP_IsClientVIP(client) || !VIP_IsClientFeatureUse(client, g_sFeature))
		return Plugin_Continue;
	
	char sWeapon[20]; int iSlot; 
	GetEdictClassname(weapon, sWeapon, sizeof(sWeapon));
	if (!GetTrieValue(g_hTrie, sWeapon[7], iSlot)) return Plugin_Continue; 
	switch(GetArraySize(g_hArray[client][iSlot]))
	{
		case 1: 
		{
			PushArrayString(g_hArray[client][iSlot], sWeapon[7]); 
			SwapArrayItems(g_hArray[client][iSlot], 0, 1);
			DeleteWeaponClient(client, weapon, iSlot, false);
		}
		case 2:
		{
			RemoveFromArray(g_hArray[client][iSlot], 1); 
			char sClientWeapon[20] = "weapon_"; 
			GetArrayString(g_hArray[client][iSlot], 0, sClientWeapon[7], 20); 
			RemoveFromArray(g_hArray[client][iSlot], 0);
			GivePlayerItem(client, sClientWeapon);
		}
		case 3: RemoveFromArray(g_hArray[client][iSlot], 1);
	}
	return Plugin_Continue; 
}

public void OnClientDisconnect(int client) 
{
	ClearArray(g_hArray[client][0]); 
	ClearArray(g_hArray[client][1]); 
}

public Action OnPlayerRunCmd(int client, int &buttons, int &impulse, float vel[3], float angles[3], int &weapon)
{
	if(!bEnable)
		return;

	if(buttons & BUTTONS && IsClientInGame(client) && IsPlayerAlive(client) || !VIP_IsClientVIP(client) || !VIP_IsClientFeatureUse(client, g_sFeature))
	{
		static int iWeapon; 
		if(!g_bReload[client] && CheckFloodClient(client) && (iWeapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon")) != -1)
		{
		
			static char sClientWeapon[20]; int iSlot; 
			GetEdictClassname(iWeapon, sClientWeapon, sizeof(sClientWeapon));
			if (!GetTrieValue(g_hTrie, sClientWeapon[7], iSlot)) g_bReload[client] = true;
			else if(GetArraySize(g_hArray[client][iSlot]) == 2) 
			{
				static char sWeapon[20] = "weapon_";
				DeleteWeaponClient(client, iWeapon, iSlot, true);
				GetArrayString(g_hArray[client][iSlot], 0, sWeapon[7], 20); 
				SwapArrayItems(g_hArray[client][iSlot], 0, 1);
				SetAmmoClient(client, GivePlayerItem(client, sWeapon), iSlot);
			}
			g_bReload[client] = true;
		}
	}
	else g_bReload[client] = false;
}

void DeleteWeaponClient(int client, int weapon, int slot, bool reload)  
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		if(reload)
		{
			g_iAmmoClient[client][slot][0] = g_iReservClient[client][slot][0];
			g_iAmmoClient [client][slot][1]= g_iReservClient[client][slot][1];
		}
		int PrimaryAmmoType = -1;
		if((PrimaryAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType")) != -1) 
		{
			g_iReservClient[client][slot][1] = GetEntProp(client, Prop_Data, "m_iAmmo", 4, PrimaryAmmoType);
			g_iReservClient[client][slot][0] = GetEntProp(weapon, Prop_Send, "m_iClip1");
		}
		if(RemovePlayerItem(client, weapon)) AcceptEntityInput(weapon, "Kill");
	}
}

void SetAmmoClient(int client, int weapon, int iSlot)
{
	int PrimaryAmmoType = -1;
	if((PrimaryAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType")) != -1) 
	{
		SetEntProp(client, Prop_Send, "m_iAmmo", g_iAmmoClient[client][iSlot][1], _, PrimaryAmmoType);
		SetEntProp(weapon, Prop_Send, "m_iClip1", g_iAmmoClient[client][iSlot][0]);
	}
}

bool CheckFloodClient(int client)
{
	float fCurTime = GetGameTime(), fNewTime = fCurTime + 0.45;
	if (g_iFloodClient[client][0] > fCurTime)
	{
		if(g_iFloodClient[client][1] > fAntiflood) 
		{
			g_iFloodClient[client][0] = fNewTime;
			return false;
		}
		g_iFloodClient[client][1]++;
	}
	else if (g_iFloodClient[client][1] > 0) g_iFloodClient[client][1]--;
	g_iFloodClient[client][0] = fNewTime;
	return true;
}